From ab4973d083af65dcd6dfd942ce962e41a24c00ca Mon Sep 17 00:00:00 2001
From: Dean M Greer <38226388+Gcenx@users.noreply.github.com>
Date: Tue, 6 Jun 2023 09:10:26 -0400
Subject: [PATCH] Game Porting Toolkit 1.0 (beta 1)

based on commit https://github.com/apple/homebrew-apple/commit/033b5e49598c5ac52858470c4f4bbdea862de99a
---
 configure                                     |    9 +
 configure.ac                                  |    4 +
 dlls/advapi32/advapi.c                        |   48 +
 dlls/advapi32/advapi32.spec                   |    8 +-
 dlls/advapi32/tests/perf.c                    |  109 +
 .../Makefile.in                               |    1 +
 .../api-ms-win-core-psm-appnotify-l1-1-0.spec |    2 +
 dlls/api-ms-win-power-base-l1-1-0/Makefile.in |    1 +
 .../api-ms-win-power-base-l1-1-0.spec         |    5 +
 dlls/atiadlxx/Makefile.in                     |    8 +
 dlls/atiadlxx/atiadlxx.spec                   | 1138 +++++++
 dlls/atiadlxx/atiadlxx_main.c                 |  576 ++++
 dlls/crypt32/base64.c                         |  183 +
 dlls/crypt32/cert.c                           |    1 +
 dlls/crypt32/chain.c                          |   63 +-
 dlls/crypt32/decode.c                         |  246 +-
 dlls/crypt32/encode.c                         |    2 +-
 dlls/crypt32/object.c                         |    2 +-
 dlls/crypt32/str.c                            |  813 ++---
 dlls/crypt32/tests/base64.c                   |  514 ++-
 dlls/crypt32/tests/cert.c                     |  689 +++-
 dlls/crypt32/tests/chain.c                    |   15 +
 dlls/crypt32/tests/encode.c                   |  151 +-
 dlls/crypt32/tests/main.c                     |    2 +-
 dlls/crypt32/tests/message.c                  |   16 +-
 dlls/crypt32/tests/msg.c                      |    4 +-
 dlls/crypt32/tests/object.c                   |  140 -
 dlls/crypt32/tests/oid.c                      |    4 +-
 dlls/crypt32/tests/store.c                    |   32 +-
 dlls/crypt32/tests/str.c                      |  697 ++--
 dlls/crypt32/unixlib.c                        |   16 +-
 dlls/cryptnet/cryptnet_main.c                 |   35 +-
 dlls/kernel32/kernel32.spec                   |    1 +
 dlls/kernelbase/kernelbase.spec               |    2 +-
 dlls/kernelbase/thread.c                      |   19 +
 dlls/mfmediaengine/Makefile.in                |    2 +
 dlls/mfmediaengine/main.c                     | 1005 ++----
 dlls/mfmediaengine/tests/Makefile.in          |    3 +-
 dlls/mfmediaengine/tests/mfmediaengine.c      |  566 +---
 dlls/mfplat/Makefile.in                       |    4 +-
 dlls/mfplat/aac_decoder.c                     |  620 ++++
 dlls/mfplat/audioconvert.c                    |  910 +++++
 dlls/mfplat/buffer.c                          |   83 +-
 dlls/mfplat/colorconvert.c                    |  901 +++++
 dlls/mfplat/decode_transform.c                | 1218 +++++++
 dlls/mfplat/gst_guids.h                       |   23 +
 dlls/mfplat/gst_private.h                     |  217 ++
 dlls/mfplat/h264_decoder.c                    |  727 ++++
 dlls/mfplat/main.c                            |  660 ++--
 dlls/mfplat/media_source.c                    | 2006 +++++++++++
 dlls/mfplat/mediatype.c                       |  142 +-
 dlls/mfplat/mfplat.c                          | 1036 ++++++
 dlls/mfplat/mfplat.spec                       |    6 +-
 dlls/mfplat/mfplat_private.h                  |    6 +-
 dlls/mfplat/quartz_parser.c                   | 1945 +++++++++++
 dlls/mfplat/queue.c                           |   14 +-
 dlls/mfplat/rsrc.rc                           |   28 +
 dlls/mfplat/sample.c                          |   27 +-
 dlls/mfplat/tests/Makefile.in                 |    1 +
 dlls/mfplat/tests/mfplat.c                    | 3007 ++++++++---------
 dlls/mfplat/unix_private.h                    |   37 +
 dlls/mfplat/unixlib.h                         |  354 ++
 dlls/mfplat/wg_parser.c                       | 2584 ++++++++++++++
 dlls/mfplat/wg_transform.c                    |  630 ++++
 dlls/mfplat/winegstreamer.rgs                 |   14 +
 dlls/mfplat/winegstreamer.spec                |    6 +
 dlls/mfplat/winegstreamer_classes.idl         |   93 +
 dlls/mfplat/wm_asyncreader.c                  | 1590 +++++++++
 dlls/mfplat/wm_reader.c                       | 2170 ++++++++++++
 dlls/mfplat/wm_syncreader.c                   |  407 +++
 dlls/mfplat/wma_decoder.c                     |  861 +++++
 dlls/ntdll/loader.c                           |   10 +-
 dlls/ntdll/unix/loader.c                      |   46 +
 dlls/ntdll/unix/signal_x86_64.c               |   16 +
 dlls/ntdll/unixlib.h                          |    6 +-
 dlls/qcap/Makefile.in                         |    1 +
 dlls/qcap/audiorecord.c                       |    8 +-
 dlls/qcap/avico.c                             |   26 +-
 dlls/qcap/avimux.c                            |   32 +-
 dlls/qcap/capturegraph.c                      |   15 +-
 dlls/qcap/filewriter.c                        |   17 +-
 dlls/qcap/tests/Makefile.in                   |    1 +
 dlls/qcap/tests/audiorecord.c                 |   82 +-
 dlls/qcap/tests/avico.c                       |  256 +-
 dlls/qcap/tests/avimux.c                      |  364 +-
 dlls/qcap/tests/capturegraph.c                |  194 +-
 dlls/qcap/tests/filewriter.c                  |  320 +-
 dlls/qcap/tests/qcap.c                        |  114 +-
 dlls/qcap/tests/smartteefilter.c              |  482 +--
 dlls/qcap/tests/videocapture.c                |  232 +-
 dlls/qcap/v4l.c                               |    4 +-
 dlls/qcap/vfwcapture.c                        |   44 +-
 dlls/quartz/Makefile.in                       |    1 +
 dlls/quartz/acmwrapper.c                      |   24 +-
 dlls/quartz/avidec.c                          |   45 +-
 dlls/quartz/dsoundrender.c                    |   40 +-
 dlls/quartz/filesource.c                      |   15 +-
 dlls/quartz/filtergraph.c                     |  672 ++--
 dlls/quartz/filtermapper.c                    |   96 +-
 dlls/quartz/main.c                            |    9 +-
 dlls/quartz/memallocator.c                    |   44 +-
 dlls/quartz/passthrough.c                     |    4 +-
 dlls/quartz/regsvr.c                          |    2 +-
 dlls/quartz/systemclock.c                     |   15 +-
 dlls/quartz/tests/Makefile.in                 |    1 +
 dlls/quartz/tests/acmwrapper.c                |  202 +-
 dlls/quartz/tests/avidec.c                    |  510 +--
 dlls/quartz/tests/avisplit.c                  |  608 ++--
 dlls/quartz/tests/dsoundrender.c              |  503 ++-
 dlls/quartz/tests/filesource.c                |  496 +--
 dlls/quartz/tests/filtergraph.c               | 1828 +++++-----
 dlls/quartz/tests/filtermapper.c              |  120 +-
 dlls/quartz/tests/memallocator.c              |  358 +-
 dlls/quartz/tests/mpegsplit.c                 |  658 ++--
 dlls/quartz/tests/passthrough.c               |   32 +-
 dlls/quartz/tests/systemclock.c               |   88 +-
 dlls/quartz/tests/videorenderer.c             | 1222 ++++---
 dlls/quartz/tests/vmr7.c                      | 1388 ++++----
 dlls/quartz/tests/vmr9.c                      | 1693 +++++-----
 dlls/quartz/tests/waveparser.c                |  388 +--
 dlls/quartz/videorenderer.c                   |   12 +-
 dlls/quartz/vmr9.c                            |  312 +-
 dlls/quartz/window.c                          |   83 +-
 dlls/windows.gaming.input/Makefile.in         |    6 +
 dlls/windows.gaming.input/async.c             |  647 ++++
 dlls/windows.gaming.input/classes.idl         |    2 +
 dlls/windows.gaming.input/condition_effect.c  |  288 ++
 dlls/windows.gaming.input/constant_effect.c   |  275 ++
 dlls/windows.gaming.input/controller.c        |   30 +-
 dlls/windows.gaming.input/force_feedback.c    |  801 +++++
 dlls/windows.gaming.input/gamepad.c           |   32 +-
 dlls/windows.gaming.input/main.c              |    9 +
 dlls/windows.gaming.input/periodic_effect.c   |  326 ++
 dlls/windows.gaming.input/private.h           |   24 +
 dlls/windows.gaming.input/provider.c          |   47 +-
 dlls/windows.gaming.input/provider.idl        |  119 +
 dlls/windows.gaming.input/racing_wheel.c      |    9 +-
 dlls/windows.gaming.input/ramp_effect.c       |  278 ++
 dlls/windows.gaming.input/vector.c            |    6 +-
 dlls/windows.gaming.ui.gamebar/Makefile.in    |    8 +
 dlls/windows.gaming.ui.gamebar/classes.idl    |   33 +
 dlls/windows.gaming.ui.gamebar/main.c         |  282 ++
 .../tests/Makefile.in                         |    5 +
 .../windows.gaming.ui.gamebar/tests/gamebar.c |   91 +
 .../windows.gaming.ui.gamebar.spec            |    3 +
 dlls/wined3d/adapter_vk.c                     |    2 +-
 dlls/winegstreamer/Makefile.in                |    7 +-
 dlls/winegstreamer/aac_decoder.c              |  620 ++++
 dlls/winegstreamer/audioconvert.c             |  390 ++-
 dlls/winegstreamer/colorconvert.c             |  901 +++++
 dlls/winegstreamer/decode_transform.c         | 1218 +++++++
 dlls/winegstreamer/gst_private.h              |   87 +-
 dlls/winegstreamer/h264_decoder.c             |  400 ++-
 dlls/winegstreamer/main.c                     |  139 +-
 dlls/winegstreamer/media_source.c             |  136 +-
 dlls/winegstreamer/mfplat.c                   |  364 +-
 dlls/winegstreamer/quartz_parser.c            |  116 +-
 dlls/winegstreamer/unix_private.h             |    5 +-
 dlls/winegstreamer/unixlib.h                  |  101 +-
 dlls/winegstreamer/wg_parser.c                | 1183 ++++++-
 dlls/winegstreamer/wg_transform.c             |  716 ++--
 dlls/winegstreamer/winegstreamer_classes.idl  |   14 +-
 dlls/winegstreamer/wm_asyncreader.c           |  133 +-
 dlls/winegstreamer/wm_reader.c                |  115 +-
 dlls/winegstreamer/wm_syncreader.c            |   34 +-
 dlls/winegstreamer/wma_decoder.c              |  490 ++-
 dlls/winemac.drv/macdrv_main.c                |   59 +
 dlls/wintrust/softpub.c                       |   91 +-
 dlls/wintrust/tests/softpub.c                 |  581 ++++
 dlls/wintrust/wintrust_main.c                 |    4 +
 include/Makefile.in                           |    2 +
 include/distversion.h                         |   12 +
 include/perflib.h                             |   27 +
 include/processthreadsapi.h                   |   15 +
 include/wincrypt.h                            |   11 +-
 include/windows.foundation.numerics.idl       |   39 +
 .../windows.gaming.input.forcefeedback.idl    |  170 +
 include/windows.gaming.input.idl              |   13 +
 include/windows.gaming.ui.idl                 |   61 +
 include/wine/strmbase.h                       |    1 +
 include/wintrust.h                            |    6 +-
 libs/strmbase/Makefile.in                     |    1 +
 libs/strmbase/dispatch.c                      |    4 +-
 libs/strmbase/filter.c                        |   64 +-
 libs/strmbase/mediatype.c                     |   38 +-
 libs/strmbase/pin.c                           |   45 +-
 libs/strmbase/pospass.c                       |   17 +-
 libs/strmbase/renderer.c                      |    2 +-
 libs/strmbase/seeking.c                       |    7 +-
 libs/strmiids/strmiids.c                      |    2 +-
 loader/preloader_mac.c                        |    4 +
 tools/make_specfiles                          |    5 +
 192 files changed, 41875 insertions(+), 13096 deletions(-)
 create mode 100644 dlls/api-ms-win-core-psm-appnotify-l1-1-0/Makefile.in
 create mode 100644 dlls/api-ms-win-core-psm-appnotify-l1-1-0/api-ms-win-core-psm-appnotify-l1-1-0.spec
 create mode 100644 dlls/api-ms-win-power-base-l1-1-0/Makefile.in
 create mode 100644 dlls/api-ms-win-power-base-l1-1-0/api-ms-win-power-base-l1-1-0.spec
 create mode 100644 dlls/atiadlxx/Makefile.in
 create mode 100644 dlls/atiadlxx/atiadlxx.spec
 create mode 100644 dlls/atiadlxx/atiadlxx_main.c
 create mode 100644 dlls/mfplat/aac_decoder.c
 create mode 100644 dlls/mfplat/audioconvert.c
 create mode 100644 dlls/mfplat/colorconvert.c
 create mode 100644 dlls/mfplat/decode_transform.c
 create mode 100644 dlls/mfplat/gst_guids.h
 create mode 100644 dlls/mfplat/gst_private.h
 create mode 100644 dlls/mfplat/h264_decoder.c
 create mode 100644 dlls/mfplat/media_source.c
 create mode 100644 dlls/mfplat/mfplat.c
 create mode 100644 dlls/mfplat/quartz_parser.c
 create mode 100644 dlls/mfplat/rsrc.rc
 create mode 100644 dlls/mfplat/unix_private.h
 create mode 100644 dlls/mfplat/unixlib.h
 create mode 100644 dlls/mfplat/wg_parser.c
 create mode 100644 dlls/mfplat/wg_transform.c
 create mode 100644 dlls/mfplat/winegstreamer.rgs
 create mode 100644 dlls/mfplat/winegstreamer.spec
 create mode 100644 dlls/mfplat/winegstreamer_classes.idl
 create mode 100644 dlls/mfplat/wm_asyncreader.c
 create mode 100644 dlls/mfplat/wm_reader.c
 create mode 100644 dlls/mfplat/wm_syncreader.c
 create mode 100644 dlls/mfplat/wma_decoder.c
 create mode 100644 dlls/windows.gaming.input/async.c
 create mode 100644 dlls/windows.gaming.input/condition_effect.c
 create mode 100644 dlls/windows.gaming.input/constant_effect.c
 create mode 100644 dlls/windows.gaming.input/force_feedback.c
 create mode 100644 dlls/windows.gaming.input/periodic_effect.c
 create mode 100644 dlls/windows.gaming.input/ramp_effect.c
 create mode 100644 dlls/windows.gaming.ui.gamebar/Makefile.in
 create mode 100644 dlls/windows.gaming.ui.gamebar/classes.idl
 create mode 100644 dlls/windows.gaming.ui.gamebar/main.c
 create mode 100644 dlls/windows.gaming.ui.gamebar/tests/Makefile.in
 create mode 100644 dlls/windows.gaming.ui.gamebar/tests/gamebar.c
 create mode 100644 dlls/windows.gaming.ui.gamebar/windows.gaming.ui.gamebar.spec
 create mode 100644 dlls/winegstreamer/aac_decoder.c
 create mode 100644 dlls/winegstreamer/colorconvert.c
 create mode 100644 dlls/winegstreamer/decode_transform.c
 create mode 100644 include/distversion.h
 create mode 100644 include/windows.foundation.numerics.idl
 create mode 100644 include/windows.gaming.ui.idl

diff --git a/configure.ac b/configure.ac
index 50c50d15e..8fad7462d 100644
--- a/configure.ac
+++ b/configure.ac
@@ -2424,6 +2424,8 @@ WINE_CONFIG_MAKEFILE(dlls/apisetschema)
 WINE_CONFIG_MAKEFILE(dlls/apphelp)
 WINE_CONFIG_MAKEFILE(dlls/apphelp/tests)
 WINE_CONFIG_MAKEFILE(dlls/appwiz.cpl)
+WINE_CONFIG_MAKEFILE(dlls/atiadlxx)
+WINE_CONFIG_MAKEFILE(dlls/api-ms-win-power-base-l1-1-0)
 WINE_CONFIG_MAKEFILE(dlls/atl)
 WINE_CONFIG_MAKEFILE(dlls/atl/tests)
 WINE_CONFIG_MAKEFILE(dlls/atl100)
@@ -3173,6 +3175,8 @@ WINE_CONFIG_MAKEFILE(dlls/windebug.dll16,enable_win16)
 WINE_CONFIG_MAKEFILE(dlls/windows.devices.enumeration)
 WINE_CONFIG_MAKEFILE(dlls/windows.gaming.input)
 WINE_CONFIG_MAKEFILE(dlls/windows.gaming.input/tests)
+WINE_CONFIG_MAKEFILE(dlls/windows.gaming.ui.gamebar)
+WINE_CONFIG_MAKEFILE(dlls/windows.gaming.ui.gamebar/tests)
 WINE_CONFIG_MAKEFILE(dlls/windows.globalization)
 WINE_CONFIG_MAKEFILE(dlls/windows.globalization/tests)
 WINE_CONFIG_MAKEFILE(dlls/windows.media.devices)
diff --git a/dlls/advapi32/advapi.c b/dlls/advapi32/advapi.c
index 6497ea22f..f7d6e9732 100644
--- a/dlls/advapi32/advapi.c
+++ b/dlls/advapi32/advapi.c
@@ -32,6 +32,7 @@
 #include "winerror.h"
 #include "wincred.h"
 #include "wct.h"
+#include "perflib.h"
 
 #include "wine/debug.h"
 
@@ -334,3 +335,50 @@ BOOL WINAPI GetThreadWaitChain(HWCT handle, DWORD_PTR ctx, DWORD flags, DWORD th
     SetLastError(ERROR_NOT_SUPPORTED);
     return FALSE;
 }
+
+ULONG WINAPI PerfCloseQueryHandle( HANDLE query )
+{
+    FIXME( "query %p stub.\n", query );
+
+    return ERROR_SUCCESS;
+}
+
+ULONG WINAPI PerfOpenQueryHandle( const WCHAR *machine, HANDLE *query )
+{
+    FIXME( "machine %s, query %p.\n", debugstr_w(machine), query );
+
+    if (!query) return ERROR_INVALID_PARAMETER;
+    *query = (HANDLE)0xdeadbeef;
+
+    return ERROR_SUCCESS;
+}
+
+ULONG WINAPI PerfAddCounters( HANDLE query, PERF_COUNTER_IDENTIFIER *id, DWORD size )
+{
+    FIXME( "query %p, id %p, size %lu stub.\n", query, id, size );
+
+    if (!id || size < sizeof(*id) || id->Size < sizeof(*id)) return ERROR_INVALID_PARAMETER;
+
+    id->Status = ERROR_WMI_GUID_NOT_FOUND;
+    return ERROR_SUCCESS;
+}
+
+ULONG WINAPI PerfQueryCounterData( HANDLE query, PERF_DATA_HEADER *data, DWORD data_size, DWORD *size_needed )
+{
+    FIXME( "query %p, data %p, data_size %lu, size_needed %p stub.\n", query, data, data_size, size_needed );
+
+    if (!size_needed) return ERROR_INVALID_PARAMETER;
+
+    *size_needed = sizeof(PERF_DATA_HEADER);
+
+    if (!data || data_size < sizeof(PERF_DATA_HEADER)) return ERROR_NOT_ENOUGH_MEMORY;
+
+    data->dwTotalSize = sizeof(PERF_DATA_HEADER);
+    data->dwNumCounters = 0;
+    QueryPerformanceCounter( (LARGE_INTEGER *)&data->PerfTimeStamp );
+    QueryPerformanceFrequency( (LARGE_INTEGER *)&data->PerfFreq );
+    GetSystemTimeAsFileTime( (FILETIME *)&data->PerfTime100NSec );
+    FileTimeToSystemTime( (FILETIME *)&data->PerfTime100NSec, &data->SystemTime );
+
+    return ERROR_SUCCESS;
+}
diff --git a/dlls/advapi32/advapi32.spec b/dlls/advapi32/advapi32.spec
index 3b5f587d4..1c3f59bb7 100644
--- a/dlls/advapi32/advapi32.spec
+++ b/dlls/advapi32/advapi32.spec
@@ -553,8 +553,8 @@
 @ stdcall -ret64 -import OpenTraceW(ptr)
 # @ stub OperationEnd
 # @ stub OperationStart
-# @ stub PerfAddCounters
-# @ stub PerfCloseQueryHandle
+@ stdcall PerfAddCounters(long ptr long)
+@ stdcall PerfCloseQueryHandle(long)
 @ stdcall -import PerfCreateInstance(long ptr wstr long)
 # @ stub PerfDecrementULongCounterValue
 # @ stub PerfDecrementULongLongCounterValue
@@ -564,8 +564,8 @@
 # @ stub PerfEnumerateCounterSetInstances
 # @ stub PerfIncrementULongCounterValue
 # @ stub PerfIncrementULongLongCounterValue
-# @ stub PerfOpenQueryHandle
-# @ stub PerfQueryCounterData
+@ stdcall PerfOpenQueryHandle(wstr ptr)
+@ stdcall PerfQueryCounterData(long ptr long ptr)
 # @ stub PerfQueryCounterInfo
 # @ stub PerfQueryCounterSetRegistrationInfo
 # @ stub PerfQueryInstance
diff --git a/dlls/advapi32/tests/perf.c b/dlls/advapi32/tests/perf.c
index fc07a09d3..34b6e9528 100644
--- a/dlls/advapi32/tests/perf.c
+++ b/dlls/advapi32/tests/perf.c
@@ -25,9 +25,31 @@
 #include "winerror.h"
 #include "perflib.h"
 #include "winperf.h"
+#include "winternl.h"
 
 #include "wine/test.h"
 
+#include "initguid.h"
+
+#define DEFINE_FUNCTION(name) static typeof(name) *p##name;
+DEFINE_FUNCTION(PerfCloseQueryHandle);
+DEFINE_FUNCTION(PerfOpenQueryHandle);
+DEFINE_FUNCTION(PerfAddCounters);
+DEFINE_FUNCTION(PerfQueryCounterData);
+#undef DEFINE_FUNCTION
+
+static void init_functions(void)
+{
+    HANDLE hadvapi = GetModuleHandleA("advapi32.dll");
+
+#define GET_FUNCTION(name) p##name = (void *)GetProcAddress(hadvapi, #name)
+    GET_FUNCTION(PerfCloseQueryHandle);
+    GET_FUNCTION(PerfOpenQueryHandle);
+    GET_FUNCTION(PerfAddCounters);
+    GET_FUNCTION(PerfQueryCounterData);
+#undef GET_FUNCTION
+}
+
 static ULONG WINAPI test_provider_callback(ULONG code, void *buffer, ULONG size)
 {
     ok(0, "Provider callback called.\n");
@@ -188,7 +210,94 @@ void test_provider_init(void)
     ok(!ret, "Got unexpected ret %lu.\n", ret);
 }
 
+DEFINE_GUID(TestCounterGUID, 0x12345678, 0x1234, 0x5678, 0x12, 0x34, 0x11, 0x11, 0x22, 0x22, 0x33, 0x33);
+
+static ULONG64 trunc_nttime_ms(ULONG64 t)
+{
+    return (t / 10000) * 10000;
+}
+
+static void test_perf_counters(void)
+{
+    LARGE_INTEGER freq, qpc1, qpc2, nttime1, nttime2, systime;
+    char buffer[sizeof(PERF_COUNTER_IDENTIFIER) + 8];
+    PERF_COUNTER_IDENTIFIER *counter_id;
+    PERF_DATA_HEADER dh;
+    HANDLE query;
+    DWORD size;
+    ULONG ret;
+
+    if (!pPerfOpenQueryHandle)
+    {
+        win_skip("PerfOpenQueryHandle not found.\n");
+        return;
+    }
+
+    ret = pPerfOpenQueryHandle(NULL, NULL);
+    ok(ret == ERROR_INVALID_PARAMETER, "got ret %lu.\n", ret);
+    ret = pPerfOpenQueryHandle(NULL, &query);
+    ok(!ret, "got ret %lu.\n", ret);
+
+    counter_id = (PERF_COUNTER_IDENTIFIER *)buffer;
+    memset(buffer, 0, sizeof(buffer));
+
+    counter_id->CounterSetGuid = TestCounterGUID;
+    counter_id->CounterId = PERF_WILDCARD_COUNTER;
+    counter_id->InstanceId = PERF_WILDCARD_COUNTER;
+
+    ret = pPerfAddCounters(query, counter_id, sizeof(*counter_id));
+    ok(ret == ERROR_INVALID_PARAMETER, "got ret %lu.\n", ret);
+
+    counter_id->Size = sizeof(*counter_id);
+    ret = pPerfAddCounters(query, counter_id, 8);
+    ok(ret == ERROR_INVALID_PARAMETER, "got ret %lu.\n", ret);
+    ret = pPerfAddCounters(query, counter_id, sizeof(*counter_id));
+    ok(!ret, "got ret %lu.\n", ret);
+    ok(counter_id->Status == ERROR_WMI_GUID_NOT_FOUND, "got Status %#lx.\n", counter_id->Status);
+
+    ret = pPerfQueryCounterData(query, NULL, 0, NULL);
+    ok(ret == ERROR_INVALID_PARAMETER, "got ret %lu.\n", ret);
+
+    size = 0xdeadbeef;
+    ret = pPerfQueryCounterData(query, NULL, 0, &size);
+    ok(ret == ERROR_NOT_ENOUGH_MEMORY, "got ret %lu.\n", ret);
+    ok(size == sizeof(dh), "got size %lu.\n", size);
+
+    ret = pPerfQueryCounterData(query, &dh, sizeof(dh), NULL);
+    ok(ret == ERROR_INVALID_PARAMETER, "got ret %lu.\n", ret);
+
+    QueryPerformanceFrequency(&freq);
+    QueryPerformanceCounter(&qpc1);
+    NtQuerySystemTime(&nttime1);
+
+    size = 0xdeadbeef;
+    ret = pPerfQueryCounterData(query, &dh, sizeof(dh), &size);
+    QueryPerformanceCounter(&qpc2);
+    NtQuerySystemTime(&nttime2);
+    SystemTimeToFileTime(&dh.SystemTime, (FILETIME *)&systime);
+    ok(!ret, "got ret %lu.\n", ret);
+    ok(size == sizeof(dh), "got size %lu.\n", size);
+    ok(dh.dwTotalSize == sizeof(dh), "got dwTotalSize %lu.\n", dh.dwTotalSize);
+    ok(!dh.dwNumCounters, "got dwNumCounters %lu.\n", dh.dwNumCounters);
+    ok(dh.PerfFreq == freq.QuadPart, "got PerfFreq %I64u.\n", dh.PerfFreq);
+    ok(dh.PerfTimeStamp >= qpc1.QuadPart && dh.PerfTimeStamp <= qpc2.QuadPart,
+            "got PerfTimeStamp %I64u, qpc1 %I64u, qpc2 %I64u.\n",
+            dh.PerfTimeStamp, qpc1.QuadPart, qpc2.QuadPart);
+    ok(dh.PerfTime100NSec >= nttime1.QuadPart && dh.PerfTime100NSec <= nttime2.QuadPart,
+            "got PerfTime100NSec %I64u, nttime1 %I64u, nttime2 %I64u.\n",
+            dh.PerfTime100NSec, nttime1.QuadPart, nttime2.QuadPart);
+    ok(systime.QuadPart >= trunc_nttime_ms(nttime1.QuadPart) && systime.QuadPart <= trunc_nttime_ms(nttime2.QuadPart),
+            "got systime %I64u, nttime1 %I64u, nttime2 %I64u, %d.\n",
+            systime.QuadPart, nttime1.QuadPart, nttime2.QuadPart, dh.SystemTime.wMilliseconds);
+
+    ret = pPerfCloseQueryHandle(query);
+    ok(!ret, "got ret %lu.\n", ret);
+}
+
 START_TEST(perf)
 {
+    init_functions();
+
     test_provider_init();
+    test_perf_counters();
 }
diff --git a/dlls/api-ms-win-core-psm-appnotify-l1-1-0/api-ms-win-core-psm-appnotify-l1-1-0.spec b/dlls/api-ms-win-core-psm-appnotify-l1-1-0/api-ms-win-core-psm-appnotify-l1-1-0.spec
new file mode 100644
index 000000000..8b069d66e
--- /dev/null
+++ b/dlls/api-ms-win-core-psm-appnotify-l1-1-0/api-ms-win-core-psm-appnotify-l1-1-0.spec
@@ -0,0 +1,2 @@
+@ stub RegisterAppStateChangeNotification
+@ stub UnregisterAppStateChangeNotification
diff --git a/dlls/api-ms-win-power-base-l1-1-0/api-ms-win-power-base-l1-1-0.spec b/dlls/api-ms-win-power-base-l1-1-0/api-ms-win-power-base-l1-1-0.spec
new file mode 100644
index 000000000..dd056946a
--- /dev/null
+++ b/dlls/api-ms-win-power-base-l1-1-0/api-ms-win-power-base-l1-1-0.spec
@@ -0,0 +1,5 @@
+@ stdcall CallNtPowerInformation(long ptr long ptr long) powrprof.CallNtPowerInformation
+@ stdcall GetPwrCapabilities(ptr) powrprof.GetPwrCapabilities
+@ stdcall PowerDeterminePlatformRoleEx(long) powrprof.PowerDeterminePlatformRoleEx
+@ stdcall PowerRegisterSuspendResumeNotification(long ptr ptr) powrprof.PowerRegisterSuspendResumeNotification
+@ stub PowerUnregisterSuspendResumeNotification
